org.apache.cassandra.db.marshal

## Class UUIDType

- java.lang.Object
- - org.apache.cassandra.db.marshal.AbstractType<java.util.UUID>
  - - org.apache.cassandra.db.marshal.UUIDType

All Implemented Interfaces:
  java.util.Comparator<java.nio.ByteBuffer>

    public class UUIDType
    extends AbstractType<java.util.UUID>

Compares UUIDs using the following criteria:
- if count of supplied bytes is less than 16, compare counts
- compare UUID version fields
- nil UUID is always lesser
- compare timestamps if both are time-based
- compare lexically, unsigned msb-to-lsb comparison

See Also:
  "com.fasterxml.uuid.UUIDComparator"

### Field Summary

Fields
`static UUIDType` `instance`

### Fields inherited from class org.apache.cassandra.db.marshal.AbstractType

`reverseComparator`

### Method Summary

All Methods Instance Methods Concrete Methods
`CQL3Type` `asCQL3Type()`
`int` `compare(java.nio.ByteBuffer b1, java.nio.ByteBuffer b2)`
`Term` `fromJSONObject(java.lang.Object parsed)` Given a parsed JSON string, return a byte representation of the object.
`java.nio.ByteBuffer` `fromString(java.lang.String source)` get a byte representation of the given string.
`TypeSerializer<java.util.UUID>` `getSerializer()`
`boolean` `isEmptyValueMeaningless()` Returns `true` for types where empty should be handled like `null` like `Int32Type`.
`boolean` `isValueCompatibleWithInternal(AbstractType<?> otherType)` Needed to handle ReversedType in value-compatibility checks.

### Methods inherited from class org.apache.cassandra.db.marshal.AbstractType

`asCQLTypeStringList, compareCollectionMembers, componentsCount, compose, decompose, freeze, getComponents, getString, getString, isByteOrderComparable, isCollection, isCompatibleWith, isCounter, isFrozenCollection, isMultiCell, isReversed, isValueCompatibleWith, parseDefaultParameters, references, toJSONString, toString, toString, validate, validateCellValue, validateCollectionMember`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Comparator

`comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

### Field Detail

#### instance

    public static final UUIDType instance

### Method Detail

#### isEmptyValueMeaningless

    public boolean isEmptyValueMeaningless()

Description copied from class: `AbstractType`
Returns `true` for types where empty should be handled like `null` like `Int32Type`.

Overrides:
  `isEmptyValueMeaningless` in class `AbstractType<java.util.UUID>`

#### compare

    public int compare(java.nio.ByteBuffer b1,
                       java.nio.ByteBuffer b2)

#### isValueCompatibleWithInternal

    public boolean isValueCompatibleWithInternal(AbstractType<?> otherType)

Description copied from class: `AbstractType`
Needed to handle ReversedType in value-compatibility checks. Subclasses should implement this instead of isValueCompatibleWith().

Overrides:
  `isValueCompatibleWithInternal` in class `AbstractType<java.util.UUID>`

#### fromString

    public java.nio.ByteBuffer fromString(java.lang.String source)
                                   throws MarshalException

Description copied from class: `AbstractType`
get a byte representation of the given string.

Specified by:
  `fromString` in class `AbstractType<java.util.UUID>`
Throws:
  `MarshalException`

#### asCQL3Type

    public CQL3Type asCQL3Type()

Overrides:
  `asCQL3Type` in class `AbstractType<java.util.UUID>`

#### getSerializer

    public TypeSerializer<java.util.UUID> getSerializer()

Specified by:
  `getSerializer` in class `AbstractType<java.util.UUID>`

#### fromJSONObject

    public Term fromJSONObject(java.lang.Object parsed)
                        throws MarshalException

Description copied from class: `AbstractType`
Given a parsed JSON string, return a byte representation of the object.

Specified by:
  `fromJSONObject` in class `AbstractType<java.util.UUID>`
Parameters:
  `parsed` - the result of parsing a json string
Throws:
  `MarshalException`